addLights = #()
addGeo = #()
Lightmix=false
Env = false
lElements = #();	
lElemNames = #();	
assignedLights = #();
 lselect = CShading_LightSelect
re = maxOps.GetCurRenderElementMgr();
allLights = #()
allLightsNames = #()
assignedGeo = #();
LightGeo = #()
allGeo = #()
allGeoNames = #()
		for i in 0 to re.NumRenderElements()-1 do
		(
			if (Classof (re.getrenderElement i))==CShading_LightMix do (Lightmix = True);
			temp =	(re.getrenderElement i)
			if (temp.name)=="Lselect_Env" do (Env = True);		
		)
		if Lightmix== False do (re.addrenderelement(CShading_LightMix elementname:"LightMix"))
		if Env== False do (re.addrenderelement(lselect elementname:"Lselect_Env" useDenoise:true addEnvironment:true ))
fn UpdateElements=
	(			
		 lselect = CShading_LightSelect
			re = maxOps.GetCurRenderElementMgr();
			x=re.Numrenderelements();	
			lElements = #();	
			lElemNames = #();	
			assignedLights = #();
			assignedGeo =#()
				for i in 0 to x do 
					(
						if  (classof (re.getrenderElement i) == CShading_LightSelect) do 
						(
							append lElements (re.getrenderElement i); 
							append lElemNames (re.getrenderElement i).name  
							
							)
					)
					
					for i in lElements do
					(
						assignedLights += i.includedNodes
						)
						
				for i in geometry do
				(
					if (classof i.material) == CoronaLightMtl do (append lightGeo i)
				)
				for i in lElements do
				(
						assignedGeo += i.includedNodes
					)
				
	)
	UpdateElements()
	
	
	fn getUnassignedLights =
		(	
			allLights = #()
			allLightsNames = #()
			lightGeo =#()
			for i in geometry do
				(
					if (classof i.material) == CoronaLightMtl do (append lightGeo i)
				)
			(
				
				Id =1
				for i in lights do
				( 
					if (findItem assignedLights i == 0)do
					(					
						id += 1
						if  (superclassof i == light) do 
						( 
							--i.name = edt2.text + id as string
							append allLights i; 
							append allLightsNames i.name
							)
						)
					)
					
				)
				return allLightsNames
			)
		getUnassignedLights()	
			
			
	fn getUnassignedGeo =
		(	
			allGeo = #()
			allGeoNames = #()
			lightGeo =#()
			for i in geometry do
				(
					if (classof i.material) == CoronaLightMtl do (append lightGeo i)
				)
			(
				
				Id =1
				for i in LightGeo do
				( 
					if (findItem assignedGeo i == 0)do
					(					
						id += 1
						--if  (superclassof i == light) do 
						( 
							--i.name = edt2.text + id as string
							append allGeo i; 
							append allGeoNames i.name
							)
						)
					)
					
				)
				return allGeoNames
			)
		getUnassignedGeo()	
	fn createLightSelect named nodes denoised env=
	(
		UpdateElements()
		re.addrenderelement (lselect elementname:("Lselect_"+ named ) useDenoise:denoised  addEnvironment:env includedNodes:nodes  )
		--re.RemoveRenderElement Lightmix

		--Lightmix = False
		--Env = False
		
		)
		
	fn RemoveLights nodes =
		(
			for i in 0 to re.NumRenderElements()-1 do
			(
				temp =	(re.getrenderElement i)
				if ((classof temp) == CShading_LightSelect) do 
				(
					warning = false
					
					CurrentNodes = temp.includedNodes
					try (deleteitem  CurrentNodes (findItem CurrentNodes undefined))catch()
						for i in nodes do
						(
						try (if	(findItem CurrentNodes i != 0) do (DeleteItem CurrentNodes (findItem CurrentNodes i); warning = true;))catch()
							)
						if warning==true do (messagebox ("There were duplicated lights on render element "+temp.name+" they have been removed from it and added to the new created Element"))	
						temp.includedNodes = CurrentNodes	
						warning = false
					)
			)
		)
		
fn renameObjArray torename newname =
	(
		id = 1
		for i in torename do
		(
			id +=1
			fixedName = ((Classof i) as string)+"_"+newname+ (id as string)
			i.name = fixedname
		)
	)
fn substractArray A B=
(
	
	for i in B do
	(
		index = finditem A i
		if index != 0 do (deleteitem A index)
	)
)

fn findReElement elName reMgr=
(
	for i in 1 to reMgr.NumRenderElements() do
	(
		rele = reMgr.GetRenderElement i
		if rele.name == elName do (return reMgr.GetRenderElement i)
	)
)
rollout add_Corona_mask "Add Light Select" width:160 height:589
(
	button 'btn2' "Create Light Select" pos:[9,33] width:108 height:20 align:#left
	listbox 'lbx1' "Light Select Elements" pos:[10,124] width:135 height:5 selection:0 align:#left  items:lElemNames


	listbox 'lbx7' "Unassigned Scene Lights" pos:[16,267] width:132 height:6 selection:0 align:#left  items:allLightsNames


	edittext 'edt2' "" pos:[8,4] width:139 height:24 align:#left
	button 'btn_Delete' "DELETE Sel Rend Elem" pos:[16,215] width:122 height:20 align:#left
	button 'btn_Update' "Refresh" pos:[24,552] width:114 height:23 align:#left
	GroupBox 'grp1' "GroupBox" pos:[5,103] width:153 height:157 align:#left
	button 'btn_Select' "Select Unassigned Lights" pos:[16,377] width:136 height:24 align:#left
	checkbox 'chk1' "Prevent Duplicates" pos:[17,56] width:128 height:16 checked:true align:#left
	button 'ren' "Rn" pos:[120,33] width:32 height:20 align:#left
	
	button 'plus' "+" pos:[18,239] width:32 height:16 toolTip:"Add selected Object" align:#left
	button 'minus' "-" pos:[103,239] width:32 height:16 toolTip:"Add selected Object" align:#left
	radiobuttons 'rdo1' "Filter Lights and/or Geo " pos:[14,74] width:87 height:30 labels:#("L","L&G","G") columns:3 align:#left
	button 'btn22' "Select Unassigned Geo" pos:[16,519] width:136 height:24 align:#left
	listbox 'lbx10' "Unassigned Light Geo" pos:[14,410] width:132 height:6 selection:0 align:#left items:allGeoNames
	on btn2 pressed do
	(
	if ($ != undefined) then
	(
		 addLights = #()
		addGeo = #()
		lightGeo=#()
		addLightAndGeo= #()
		--removeLights = #()
		Id =1
		elName = edt2.text
		--if elName == "" do( elName = 
		for i in geometry do
				(
					if (classof i.material) == CoronaLightMtl do (append lightGeo i)
				)
		for i in selection do
		(
			id += 1
			if  (superclassof i == light) do 
				( 
					i.name =  ((Classof i) as string)+"_"+edt2.text +"_"+ id as string
					append addLights i; 
					append addLightAndGeo i
					)
				if  ((superclassof i == geometryClass) And (classof i.material) == CoronaLightMtl ) do 
				( 
					append addGeo i
					append addLightAndGeo i
					)
				
			)

			
			
			if rdo1.state==1 do( if chk1.checked==true do (RemoveLights addLights); createLightSelect edt2.text addLights True False)
			if rdo1.state==2 do( if chk1.checked==true do (RemoveLights addLightAndGeo); createLightSelect edt2.text addLightAndGeo True False)
			if rdo1.state==3 do( if chk1.checked==true do (RemoveLights addGeo); createLightSelect edt2.text addGeo True False)
			UpdateElements()
			getUnassignedLights()
			getUnassignedGeo()	
			lbx1.items = lElemNames 
			lbx7.items = allLightsNames
			lbx10.items = allGeoNames
		)
		else
		(
			messagebox ("please select the ligth to add");
			)
		
		
	)
	on lbx1 doubleClicked itm do
	(
		if (lElements[itm].includedNodes.count > 0) then
		(
		select (lElements[itm].includedNodes as array)
		)
		else
		(
			messagebox ("This Render element does not have any lights")
			)
		
	)
	on lbx7 doubleClicked itm do
	(
		select allLights[itm]
	)
	on btn_Delete pressed do
	(
		sel = lbx1.selection
		if (sel != 0) do
		(
			re.RemoveRenderElement lElements[sel]
			UpdateElements()
			getUnassignedLights()
			getUnassignedGeo()	
			lbx1.items = lElemNames 
			lbx7.items = allLightsNames
			lbx10.items = allGeoNames
			
			)
		
		)
	on btn_Update pressed do
	(
		UpdateElements()
		getUnassignedLights()
		getUnassignedGeo()	
		lbx1.items = lElemNames 
		lbx7.items = allLightsNames
		lbx10.items = allGeoNames
	)
	on btn_Select pressed do
	(
		select allLights
	)
	on btn22 pressed do
	(
		select allGeo
	)
	on lbx10 doubleClicked itm do
	(
		select allGeo[itm]
	)
	on plus pressed do
	(
		
		sel = lbx1.selection
		if (sel != 0 And $ !=undefined) do
		(
			id= 1
			 
			CurrentNodes = #()
			seltxt = lbx1.selected
			temp = findReElement seltxt re
			plusLights = selection as array
			if chk1.checked==true do (RemoveLights plusLights )
			tempName = replace temp.name 1 8 ""
			CurrentNodes = temp.includedNodes
			for i in plusLights do
				(
					id +=1
					if  (superclassof i == light or ((superclassof i == geometryClass) And (classof i.material== CoronaLightMtl))And (findItem CurrentNodes i == 0)) do 
						(
										if  (superclassof i == light) do (i.name =  ((Classof i) as string)+"_"+tempName +"_"+ id as string)
							
							if rdo1.state==1 and superclassof i == light   do (append temp.includedNodes i)
							if rdo1.state==2 do(append temp.includedNodes i)
							if rdo1.state==3 and superclassof i == geometryClass   do (append temp.includedNodes i)
							)

				)
		UpdateElements()
		getUnassignedLights()
		getUnassignedGeo()	
		lbx1.items = lElemNames 
		lbx7.items = allLightsNames
		lbx10.items = allGeoNames
		if (temp.includedNodes.count > 0) then
		(
		select (temp.includedNodes as array)
		)
		else
		(
			messagebox ("This Render element does not have any lights")
			)
		
		)
		
	)
	
	on minus pressed do
		
	(
			
		sel = lbx1.selection
		if (sel != 0 And $ !=undefined) do
		(
			
			CurrentNodes = #()
			seltxt = lbx1.selected
			temp = findReElement seltxt re
			remLights = selection as array
			tempName = replace temp.name 1 8 ""
			CurrentNodes = temp.includedNodes
				for i in remLights do
				(
					
					if rdo1.state==1 and superclassof i == light   do (try (deleteItem temp.includedNodes (finditem temp.includedNodes i))catch())
					if rdo1.state==2 do(try (deleteItem temp.includedNodes (finditem temp.includedNodes i))catch())
					if rdo1.state==3 and superclassof i == geometryClass   do (try (deleteItem temp.includedNodes (finditem temp.includedNodes i))catch())
					
				)
				
				UpdateElements()
				getUnassignedLights()
				getUnassignedGeo()	
				lbx1.items = lElemNames 
				lbx7.items = allLightsNames
				lbx10.items = allGeoNames
				
				if (temp.includedNodes.count > 0) then
				(
				select (temp.includedNodes as array)
				)
				else
				(
					messagebox ("This Render element does not have any lights")
					)
				)
		
		
		
	)
	
	on ren pressed do
	(
	sel = lbx1.selection
		if (sel != 0) do
		(
			id = 1
			seltxt = lbx1.selected
			temp = findReElement seltxt re
			temp.name = (substring temp.name 1 8)+edt2.text
		UpdateElements()
		getUnassignedLights()
		getUnassignedGeo()	
		lbx1.items = lElemNames 
		lbx7.items = allLightsNames
		lbx10.items = allGeoNames
			
		)
		
	)
	
	
)

	tbFloater = newRolloutFloater "Light Select Helper" 170 610
	addRollout add_Corona_mask tbFloater

-------------------


